﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Net;
using System.Text;
using System.IO;
using Newtonsoft.Json;

namespace CSharpSampleProject
{
    public partial class InventoryCategory : System.Web.UI.Page
    {
        string CreateCategoryUrl = "https://jobapi.tasq.com.au/api/Item/CreateCategory";
        string EditCategoryUrl = "https://jobapi.tasq.com.au/api/Item/EditCategory";
        string DeleteCategoryUrl = "https://jobapi.tasq.com.au/api/Item/DeleteInventoryCategory";
        string GetCategoryListUrl = "https://jobapi.tasq.com.au/api/Item/GetCategoryList?Jsonlogin={\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"}";

        string CreateCategoryContent = "{\"CompanyValidateInfo\":{\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"},\"Category\":{\"CategoryID\":\"218b15db-3136-4d0d-b126-c8bc19943bf3\",\"CategoryName\":\"C1\",\"IsInactive\":false,\"HasExportedToQ6\":false}}";
        string EditCategoryContent = "{\"CompanyValidateInfo\":{\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"},\"Category\":{\"CategoryID\":\"218b15db-3136-4d0d-b126-c8bc19943bf3\",\"CategoryName\":\"C1\",\"IsInactive\":true,\"HasExportedToQ6\":false}}";
        string DeleteCategoryContent = "{\"CompanyValidateInfo\":{\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"},\"ID\":\"c69552f0-327a-48cc-a549-02288176930f\",\"SendFromUserID\":null,\"NeedValidate\":false}";

        protected void Page_Load(object sender, EventArgs e)
        {

        }


        public static string PostData(string Url, string content)
        {
            string result = "";
            HttpWebRequest req = (HttpWebRequest)WebRequest.Create(Url);
            req.Method = "POST";
            req.ContentType = "application/json";

            #region Add Post Param
            byte[] data = Encoding.UTF8.GetBytes(content);
            req.ContentLength = data.Length;
            using (Stream reqStream = req.GetRequestStream())
            {
                reqStream.Write(data, 0, data.Length);
                reqStream.Close();
            }
            #endregion

            HttpWebResponse resp = (HttpWebResponse)req.GetResponse();
            Stream stream = resp.GetResponseStream();
            using (StreamReader reader = new StreamReader(stream, Encoding.UTF8))
            {
                result = reader.ReadToEnd();
            }
            return result;
        }

        public static string GetData(string Url)
        {
            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(Url);
            request.Method = "GET";
            request.ContentType = "application/json";

            HttpWebResponse response = (HttpWebResponse)request.GetResponse();
            Stream myResponseStream = response.GetResponseStream();
            StreamReader myStreamReader = new StreamReader(myResponseStream, Encoding.UTF8);
            string retString = myStreamReader.ReadToEnd();

            myStreamReader.Close();
            myResponseStream.Close();

            if (response != null)
            {
                response.Close();
            }
            if (request != null)
            {
                request.Abort();
            }

            return retString;
        }


        protected void btnCreateCategory_Click(object sender, EventArgs e)
        {
            string strMessage = PostData(CreateCategoryUrl, CreateCategoryContent);
            json.InnerText = ConvertJsonString(strMessage);
        }

        protected void btnEditCategory_Click(object sender, EventArgs e)
        {
            string strMessage = PostData(EditCategoryUrl, EditCategoryContent);
            json.InnerText = ConvertJsonString(strMessage);
        }

        protected void btnDeleteCategory_Click(object sender, EventArgs e)
        {
            string strMessage = PostData(DeleteCategoryUrl, DeleteCategoryContent);
            json.InnerText = ConvertJsonString(strMessage);
        }

        protected void btnGetCategoryList_Click(object sender, EventArgs e)
        {
            string strMessage = GetData(GetCategoryListUrl);
            json.InnerText = ConvertJsonString(strMessage);
        }

        private string ConvertJsonString(string str)

        {

            //格式化json字符串

            JsonSerializer serializer = new JsonSerializer();

            TextReader tr = new StringReader(str);

            JsonTextReader jtr = new JsonTextReader(tr);

            object obj = serializer.Deserialize(jtr);

            if (obj != null)

            {

                StringWriter textWriter = new StringWriter();

                JsonTextWriter jsonWriter = new JsonTextWriter(textWriter)

                {

                    Formatting = Formatting.Indented,

                    Indentation = 4,

                    IndentChar = ' '

                };

                serializer.Serialize(jsonWriter, obj);

                return textWriter.ToString();

            }

            else

            {

                return str;

            }

        }

    }
}