﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Net;
using System.Text;
using System.IO;
using Newtonsoft.Json;

namespace CSharpSampleProject
{
    public partial class Leave : System.Web.UI.Page
    {
        string CreateLeaveUrl = "https://jobapi.tasq.com.au/api/Staff/CreateLeaveUserEditHours";
        string EditLeaveUrl = "https://jobapi.tasq.com.au/api/Staff/EditStaffLeaveUserEditHours";
        string DeleteLeaveUrl = "https://jobapi.tasq.com.au/api/Staff/DeleteLeave";
        string GetLeaveListUrl = "https://jobapi.tasq.com.au/api/Staff/GetLeaveList?Jsonlogin={\"LoginName\":\"testapi%40tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"}&Type=All&StartTime=2019-11-04&EndTime=2019-12-04&StaffID=";

        string CreateLeaveContent = "{\"CompanyValidateInfo\":{\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"},\"Leave\":{\"LeaveID\":\"00000000-0000-0000-0000-000000000000\",\"ReferenceNO\":null,\"StaffID\":\"6927ca05-f2d8-48ad-9f0d-bc8ddc9bb8c1\",\"LeaveType\":\"00000000-0000-0000-0000-000000000000\",\"StartTime\":\"2019-11-04T09:00:00\",\"EndTime\":\"2019-11-04T09:30:00\",\"Totalhours\":0.50,\"hasApproval\":true,\"IsDeleted\":false,\"CreateTimeUTC\":\"0001-01-01T00:00:00\",\"CreatedBy\":null,\"LastModifiedTimeUTC\":\"0001-01-01T00:00:00\",\"LastModifiedBy\":null,\"Memo\":\"aaa\",\"LeaveTypeName\":\"66\"}}";
        string EditLeaveContent = "{\"CompanyValidateInfo\":{\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"},\"Leave\":{\"LeaveID\":\"7b4a2270-8d0b-4e5c-ad17-765eaa7f01f1\",\"ReferenceNO\":null,\"StaffID\":\"6927ca05-f2d8-48ad-9f0d-bc8ddc9bb8c1\",\"LeaveType\":\"00000000-0000-0000-0000-000000000000\",\"StartTime\":\"2019-11-04T09:00:00\",\"EndTime\":\"2019-11-04T09:30:00\",\"Totalhours\":0.50,\"hasApproval\":true,\"IsDeleted\":false,\"CreateTimeUTC\":\"0001-01-01T00:00:00\",\"CreatedBy\":null,\"LastModifiedTimeUTC\":\"0001-01-01T00:00:00\",\"LastModifiedBy\":null,\"Memo\":\"aaaaa\",\"LeaveTypeName\":\"66\"}}";
        string DeleteLeaveContent = "{\"CompanyValidateInfo\":{\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"},\"ID\":\"0EA4891F-F6EC-4B6B-8D24-DE0307671068\",\"SendFromUserID\":null,\"NeedValidate\":false}";
        public static string PostData(string Url, string content)
        {
            string result = "";
            HttpWebRequest req = (HttpWebRequest)WebRequest.Create(Url);
            req.Method = "POST";
            req.ContentType = "application/json";

            #region Add Post Param
            byte[] data = Encoding.UTF8.GetBytes(content);
            req.ContentLength = data.Length;
            using (Stream reqStream = req.GetRequestStream())
            {
                reqStream.Write(data, 0, data.Length);
                reqStream.Close();
            }
            #endregion

            HttpWebResponse resp = (HttpWebResponse)req.GetResponse();
            Stream stream = resp.GetResponseStream();
            using (StreamReader reader = new StreamReader(stream, Encoding.UTF8))
            {
                result = reader.ReadToEnd();
            }
            return result;
        }

        public static string GetData(string Url)
        {
            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(Url);
            request.Method = "GET";
            request.ContentType = "application/json";

            HttpWebResponse response = (HttpWebResponse)request.GetResponse();
            Stream myResponseStream = response.GetResponseStream();
            StreamReader myStreamReader = new StreamReader(myResponseStream, Encoding.UTF8);
            string retString = myStreamReader.ReadToEnd();

            myStreamReader.Close();
            myResponseStream.Close();

            if (response != null)
            {
                response.Close();
            }
            if (request != null)
            {
                request.Abort();
            }

            return retString;
        }


        protected void btnCreateLeave_Click(object sender, EventArgs e)
        {
            string strMessage = PostData(CreateLeaveUrl, CreateLeaveContent);
            json.InnerText = ConvertJsonString(strMessage);
        }

        protected void btnEditLeave_Click(object sender, EventArgs e)
        {
            string strMessage = PostData(EditLeaveUrl, EditLeaveContent);
            json.InnerText = ConvertJsonString(strMessage);
        }

        protected void btnDeleteLeave_Click(object sender, EventArgs e)
        {
            string strMessage = PostData(DeleteLeaveUrl, DeleteLeaveContent);
            json.InnerText = ConvertJsonString(strMessage);
        }

        protected void btnGetLeaveList_Click(object sender, EventArgs e)
        {
            string strMessage = GetData(GetLeaveListUrl);
            json.InnerText = ConvertJsonString(strMessage);
        }

        private string ConvertJsonString(string str)

        {

            //格式化json字符串

            JsonSerializer serializer = new JsonSerializer();

            TextReader tr = new StringReader(str);

            JsonTextReader jtr = new JsonTextReader(tr);

            object obj = serializer.Deserialize(jtr);

            if (obj != null)

            {

                StringWriter textWriter = new StringWriter();

                JsonTextWriter jsonWriter = new JsonTextWriter(textWriter)

                {

                    Formatting = Formatting.Indented,

                    Indentation = 4,

                    IndentChar = ' '

                };

                serializer.Serialize(jsonWriter, obj);

                return textWriter.ToString();

            }

            else

            {

                return str;

            }

        }
    }
}