﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Net;
using System.Text;
using System.IO;
using Newtonsoft.Json;
using Newtonsoft.Json;

namespace CSharpSampleProject
{
    public partial class Staff : System.Web.UI.Page
    {
        string CreateStaffUrl = "https://jobapi.tasq.com.au/api/Q6/CreateStaff";
        string EditStaffUrl = "https://jobapi.tasq.com.au/api/Q6/EditStaff";
        string DeleteStaffUrl = "https://jobapi.tasq.com.au/api/Q6/DeleteStaff";
        string GetStaffListUrl = "https://jobapi.tasq.com.au/api/Q6/GetSearchStaffList?Jsonlogin={\"LoginName\":\"testapi%40tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"}&SearchText=";
        string CreateStaffContent = "{\"CompanyValidateInfo\":{\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"},\"InternalUser\":{\"CompanyID\":null,\"UserID\":\"00000000-0000-0000-0000-000000000000\",\"UserName\":null,\"FirstName\":\"c\",\"LastName\":\"2\",\"Mobile\":\"222222222222222\",\"LoginEmail\":\"C2@uniware.com.au\",\"Password\":null,\"OldPassword\":null,\"NewPassword\":\"richman58.\",\"IsMain\":false,\"CreateDate\":\"0001-01-01T00:00:00\",\"UserRoleID\":null,\"UserRoleName\":null,\"IsSubscriber\":false,\"ShownInDispatchJob\":true,\"StaffPhoto\":null,\"RoundingBy\":\"None\",\"ShiftStatus\":null}}";
        string EditStaffContent = "{\"CompanyValidateInfo\":{\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"},\"InternalUser\":{\"CompanyID\":null,\"UserID\":\"451444F6-F7BC-4E49-AA7A-4D091312F99F\",\"UserName\":null,\"FirstName\":\"c\",\"LastName\":\"2\",\"Mobile\":\"333333333333333\",\"LoginEmail\":\"C2@uniware.com.au\",\"Password\":null,\"OldPassword\":null,\"NewPassword\":\"\",\"IsMain\":false,\"CreateDate\":\"0001-01-01T00:00:00\",\"UserRoleID\":null,\"UserRoleName\":null,\"IsSubscriber\":false,\"ShownInDispatchJob\":true,\"StaffPhoto\":null,\"RoundingBy\":\"None\",\"ShiftStatus\":null}}";
        string DeleteStaffContent = "{\"CompanyValidateInfo\":{\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"},\"UserID\":\"9d21a158-2120-4a4b-a83c-19485a1cf300\"}";

        protected void Page_Load(object sender, EventArgs e)
        {

        }



        public static string PostData(string Url, string content)
        {
            string result = "";
            HttpWebRequest req = (HttpWebRequest)WebRequest.Create(Url);
            req.Method = "POST";
            req.ContentType = "application/json";

            #region Add Post Param
            byte[] data = Encoding.UTF8.GetBytes(content);
            req.ContentLength = data.Length;
            using (Stream reqStream = req.GetRequestStream())
            {
                reqStream.Write(data, 0, data.Length);
                reqStream.Close();
            }
            #endregion

            HttpWebResponse resp = (HttpWebResponse)req.GetResponse();
            Stream stream = resp.GetResponseStream();
            using (StreamReader reader = new StreamReader(stream, Encoding.UTF8))
            {
                result = reader.ReadToEnd();
            }
            return result;
        }

        public static string GetData(string Url)
        {
            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(Url);
            request.Method = "GET";
            request.ContentType = "application/json";

            HttpWebResponse response = (HttpWebResponse)request.GetResponse();
            Stream myResponseStream = response.GetResponseStream();
            StreamReader myStreamReader = new StreamReader(myResponseStream, Encoding.UTF8);
            string retString = myStreamReader.ReadToEnd();

            myStreamReader.Close();
            myResponseStream.Close();

            if (response != null)
            {
                response.Close();
            }
            if (request != null)
            {
                request.Abort();
            }

            return retString;
        }


        protected void btnCreateStaff_Click(object sender, EventArgs e)
        {
            string strMessage = PostData(CreateStaffUrl, CreateStaffContent);
            json.InnerText = ConvertJsonString(strMessage);
        }

        protected void btnEditStaff_Click(object sender, EventArgs e)
        {
            string strMessage = PostData(EditStaffUrl, EditStaffContent);
            json.InnerText = ConvertJsonString(strMessage);
        }

        protected void btnDeleteStaff_Click(object sender, EventArgs e)
        {
            string strMessage = PostData(DeleteStaffUrl, DeleteStaffContent);
            json.InnerText = ConvertJsonString(strMessage);
        }

        protected void btnGetStaffList_Click(object sender, EventArgs e)
        {
            string strMessage = GetData(GetStaffListUrl);
            json.InnerText = ConvertJsonString(strMessage);
        }

        private string ConvertJsonString(string str)

        {

            //格式化json字符串

            JsonSerializer serializer = new JsonSerializer();

            TextReader tr = new StringReader(str);

            JsonTextReader jtr = new JsonTextReader(tr);

            object obj = serializer.Deserialize(jtr);

            if (obj != null)

            {

                StringWriter textWriter = new StringWriter();

                JsonTextWriter jsonWriter = new JsonTextWriter(textWriter)

                {

                    Formatting = Formatting.Indented,

                    Indentation = 4,

                    IndentChar = ' '

                };

                serializer.Serialize(jsonWriter, obj);

                return textWriter.ToString();

            }

            else

            {

                return str;

            }

        }
    }
}